Attribute VB_Name = "mDBcontroller"
Public Const IMAGE_ID = "1"
Private cn As ADODB.Connection ' We use only one active connection.
Public Action As String, currentDB_Name As String

Public Function Connect(Optional DB_Name As String = "Activities.mdb") As Boolean

On Error GoTo ErrConnect
  Connect = False
  If DB_Name = "Activities.mdb" Then DB_Name = App.Path & "\" & DB_Name
  Set cn = New ADODB.Connection
' The ConnectionString contains the path of the database.
    cn.ConnectionString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source= " & DB_Name
    cn.CursorLocation = adUseClient 'to allow sort
    cn.Open
    Connect = True

  currentDB_Name = DB_Name

ErrConnect:
  If Err <> 0 Then WriteLog
  
End Function

Public Function Disconnect() As Boolean

On Error GoTo ErrDisconnect
  Disconnect = False
  
  cn.Close
  Disconnect = True
   
ErrDisconnect:
  If Err <> 0 Then WriteLog
  
End Function

Public Function ExecSQL(astrQ As String, Optional ByRef ars As ADODB.Recordset) As Boolean
  Dim rs As New ADODB.Recordset

On Error GoTo errExecSQL
  ExecSQL = False
  
'search
  If Len(strSearch) > 0 Then _
  astrQ = Replace(astrQ, "WHERE", "WHERE (objects.obj_name LIKE '%" & strSearch & "%') AND ", , 1)

  rs.Open astrQ, cn, , adLockBatchOptimistic, adCmdText
  If rs.State = adStateOpen Then 'result available
    Set ars = rs.Clone()
    rs.Close
  End If
  ExecSQL = True
  
errExecSQL:
  If Err <> 0 Then WriteLog
  
End Function

Public Function WriteLog() As Boolean

  Debug.Print Err.Number, Err.Description
  frmTreeView.Info = Err.Number & Err.Description

End Function

Public Sub ImageConversion()
' one time use

Dim strQ As String, rs As New ADODB.Recordset
Dim fso As Scripting.FileSystemObject

' image names are converted from obj_name to obj_id
  Set fso = CreateObject("Scripting.FileSystemObject")

  strQ = " SELECT objects.*, relations.dst_obj  " & _
"FROM objects LEFT JOIN relations ON objects.obj_id = relations.dst_obj " & _
"WHERE (((Relations.src_obj) = " & IMAGE_ID & ") And ((Relations.dst_obj) <> [Relations]![src_obj]));"
  If Not ExecSQL(strQ, rs) Then GoTo errImageConversion

  Do While Not rs.EOF
    fso.CopyFile App.Path & "/Images/" & Trim(rs!obj_name) & ".jpg", App.Path & "/Images_new/" & rs!Obj_id & ".jpg"
    fso.MoveFile App.Path & "/Images/" & Trim(rs!obj_name) & ".jpg", App.Path & "/Images_old/"
    rs.MoveNext
  Loop
  rs.Close

errImageConversion:
  If Err <> 0 Then WriteLog
End Sub

Public Function CreateNewRelation(Src_id As Integer, Dst_id As Integer) As Boolean
Dim strQ As String, rs As New ADODB.Recordset

On Error GoTo CreateNewRelationErr
  CreateNewRelation = False
  strQ = "INSERT INTO relations(src_obj, dst_obj, relation_seq) VALUES ( " & Src_id & "," & Dst_id & ", 1)"
  CreateNewRelation = ExecSQL(strQ)
    
CreateNewRelationErr:
  If Err <> 0 Then WriteLog

End Function

Public Function GetAllObjectsRelatedToObjectWithRelID(Src_id As Integer, rs As ADODB.Recordset) As Boolean
Dim strQ As String

On Error GoTo GetAllObjectsRelatedToObjectWithRelIDErr
  GetAllObjectsRelatedToObjectWithRelID = False
  
  strQ = "SELECT objects.*, relations.relation_id FROM objects RIGHT JOIN relations ON objects.obj_id = relations.dst_obj " & _
"WHERE (((Relations.src_obj) <> [Relations]![dst_obj]) And ((Relations.src_obj) = " & Src_id & " ))" & _
"ORDER BY objects.obj_name;"
  GetAllObjectsRelatedToObjectWithRelID = ExecSQL(strQ, rs)
  
GetAllObjectsRelatedToObjectWithRelIDErr:
  If Err <> 0 Then WriteLog
End Function

Public Function GetAllObjectsRelatedToObject_withGenInfo(Src_id As Integer, rs As ADODB.Recordset) As Boolean
Dim strQ As String

On Error GoTo GetAllObjectsRelatedToObject_withGenInfoErr
  GetAllObjectsRelatedToObject_withGenInfo = False
  
   strQ = "SELECT objects.*, objects_1.obj_id AS gen_id, objects_1.obj_name AS gen_name, relations.relation_id AS relation_id, relations_2.relation_id AS gen_relation_id " & _
"FROM (((objects RIGHT JOIN relations ON objects.obj_id = relations.dst_obj) LEFT JOIN relations AS relations_1 ON objects.obj_id = relations_1.dst_obj) LEFT JOIN relations AS relations_2 ON relations_1.src_obj = relations_2.src_obj) LEFT JOIN objects AS objects_1 ON relations_1.src_obj = objects_1.obj_id " & _
"WHERE (((Relations.src_obj) = " & Src_id & ") And ((relations_2.src_obj) = ([relations_2].[dst_obj]))) " & _
"ORDER BY objects_1.obj_name, objects.obj_name, objects.obj_id;"
    GetAllObjectsRelatedToObject_withGenInfo = ExecSQL(strQ, rs)

GetAllObjectsRelatedToObject_withGenInfoErr:
  If Err <> 0 Then WriteLog
End Function

Public Function GetGenericList(rs As ADODB.Recordset) As Boolean
Dim strQ As String

On Error GoTo GetGenericListErr
  GetGenericList = False
  
    strQ = "SELECT objects.*, relations.relation_id " & _
"FROM objects LEFT JOIN relations ON objects.obj_id = relations.dst_obj " & _
"WHERE (((Relations.src_obj) = [Relations]![dst_obj])) ORDER BY objects.obj_name;"
    GetGenericList = ExecSQL(strQ, rs)
   
GetGenericListErr:
  If Err <> 0 Then WriteLog

End Function

Public Function GetObjectInfo(Src_id As Integer, rs As ADODB.Recordset) As Boolean
Dim strQ As String

On Error GoTo GetObjectInfoErr
  GetObjectInfo = False
  
    strQ = "SELECT objects_1.*, objects.obj_id AS gen_id, objects.obj_name AS gen_name, objects.obj_comment AS gen_comment, objects.obj_createdate AS gen_createdate, objects_1.obj_updatedate AS gen_updatedate " & _
"FROM ((relations LEFT JOIN objects ON relations.src_obj = objects.obj_id) LEFT JOIN relations AS relations_1 ON relations.src_obj = relations_1.src_obj) INNER JOIN objects AS objects_1 ON relations.dst_obj = objects_1.obj_id " & _
"WHERE (((relations_1.src_obj)=([relations_1].[dst_obj])) AND ((relations.dst_obj)= " & Src_id & " ));"
    GetObjectInfo = ExecSQL(strQ, rs)
  
GetObjectInfoErr:
  If Err <> 0 Then WriteLog

End Function

Public Function GetAllObjectsRelatedToObject1_Object2(Src1_id As Integer, Src2_id As Integer, rs As ADODB.Recordset) As Boolean
Dim strQ As String

On Error GoTo GetAllObjectsRelatedToObject1_Object2Err
  GetAllObjectsRelatedToObject1_Object2 = False
  
   strQ = "SELECT objects.* " & _
"FROM (objects RIGHT JOIN relations ON objects.obj_id = relations.dst_obj) LEFT JOIN relations AS relations_1 ON objects.obj_id = relations_1.dst_obj " & _
"WHERE (((relations_1.src_obj) = " & Src2_id & ") And ((Relations.src_obj) = " & Src1_id & ")) " & _
"ORDER BY objects.obj_name;"
    GetAllObjectsRelatedToObject1_Object2 = ExecSQL(strQ, rs)
  
GetAllObjectsRelatedToObject1_Object2Err:
  If Err <> 0 Then WriteLog

End Function

Public Function UpdateObjectInfo(Obj_id As Integer, strObj_name As String, strObj_comm As String) As Boolean
Dim strQ As String

On Error GoTo UpdateObjectInfoErr
  UpdateObjectInfo = False
  
  strObj_name = Replace(strObj_name & " ", "'", "''")
  strObj_comm = Replace(strObj_comm & " ", "'", "''")
  
   strQ = "UPDATE objects SET objects.obj_name = '" & strObj_name & "', objects.obj_comment = '" & strObj_comm & "', objects.obj_updatedate = Date() " & _
"WHERE (((objects.obj_id)= " & Obj_id & "));"
    UpdateObjectInfo = ExecSQL(strQ)

UpdateObjectInfoErr:
  If Err <> 0 Then WriteLog

End Function

Public Function CreateNewObject(strObj_name As String, strObj_comm As String, rs As ADODB.Recordset) As Boolean
Dim strQ As String

On Error GoTo CreateNewObjectErr
  CreateNewObject = False
  
  strObj_name = Replace(strObj_name & "", "'", "''")
  strObj_comm = Replace(strObj_comm & "", "'", "''")
  
'create new object
    strQ = "INSERT INTO objects(obj_name, obj_comment) VALUES ('" & strObj_name & "','" & strObj_comm & "')"
    If ExecSQL(strQ) Then 'get new object's id
      strQ = "SELECT Max(objects.obj_id) AS obj_id FROM objects"
      CreateNewObject = ExecSQL(strQ, rs)
    End If
 
CreateNewObjectErr:
  If Err <> 0 Then WriteLog
 
End Function

Public Function DeleteObject(Obj_id As Integer) As Boolean
Dim strQ As String
' delete object and all relation it is involved

On Error GoTo DeleteObjectErr
  DeleteObject = False
  
    strQ = "DELETE FROM relations WHERE src_obj = " & Obj_id & " OR dst_obj =  " & Obj_id
    If ExecSQL(strQ) Then
      strQ = "DELETE FROM objects WHERE obj_id = " & Obj_id
      DeleteObject = ExecSQL(strQ)
    End If
  
DeleteObjectErr:
  If Err <> 0 Then WriteLog
 
End Function

Public Function DeleteRelation(Src_id As Integer, dst_obj As Integer) As Boolean
Dim strQ As String

On Error GoTo DeleteRelationErr
  DeleteRelation = False
  
    strQ = "DELETE FROM relations WHERE src_obj = " & Src_id & " AND dst_obj = " & dst_obj
    DeleteRelation = ExecSQL(strQ)
  
DeleteRelationErr:
  If Err <> 0 Then WriteLog
 
End Function

Public Function GetObjectsRelatedToObjectUp_withGenInfo(Src_id As Integer, rs As ADODB.Recordset) As Boolean
Dim strQ As String

On Error GoTo GetObjectsRelatedToObjectUp_withGenInfoErr
  GetObjectsRelatedToObjectUp_withGenInfo = False
  
    strQ = "SELECT objects.*, objects_1.obj_id AS gen_id, objects_1.obj_name AS gen_name, relations.relation_id AS relation_id, relations_2.relation_id AS gen_relation_id " & _
"FROM relations LEFT JOIN (((objects LEFT JOIN relations AS relations_1 ON objects.obj_id = relations_1.dst_obj) LEFT JOIN relations AS relations_2 ON relations_1.src_obj = relations_2.src_obj) LEFT JOIN objects AS objects_1 ON relations_1.src_obj = objects_1.obj_id) ON relations.src_obj = objects.obj_id " & _
"WHERE (((Relations.dst_obj) = " & Src_id & ") And ((relations_2.src_obj) = ([relations_2].[dst_obj])) And ((relations_1.src_obj) <> ([relations_1].[dst_obj])))" & _
"ORDER BY objects_1.obj_name, objects.obj_name, objects.obj_id;"
    GetObjectsRelatedToObjectUp_withGenInfo = ExecSQL(strQ, rs)
  
GetObjectsRelatedToObjectUp_withGenInfoErr:
  If Err <> 0 Then WriteLog

End Function

Public Function ExtractTreeDown(Src_id As Integer) As Boolean
Dim rs As ADODB.Recordset
Dim strQ As String

On Error GoTo ExtractTreeDownErr
  ExtractTreeDown = False

'create new table
  strQ = "SELECT objects.* INTO objects_" & Src_id & " FROM objects WHERE ((1)=(2));"
  ExecSQL strQ
'get empty recordset for update
  strQ = "SELECT objects_" & Src_id & ".* FROM objects_" & Src_id & ";"
  ExecSQL strQ, rs
'get all objects down the tree starting from src_id, including itself and all Generics
  GetObjectsTreeDown Src_id, rs
  rs.UpdateBatch
  rs.Close
'create temp table and update with relations
  strQ = "SELECT relations.* INTO relations_" & Src_id & _
" FROM (relations INNER JOIN objects_" & Src_id & " ON relations.dst_obj = objects_" & Src_id & _
".obj_id) INNER JOIN objects_" & Src_id & " AS objects_" & Src_id & "_1 ON relations.src_obj = objects_" & Src_id & "_1.obj_id;"
  ExecSQL strQ

  ExtractTreeDown = True

ExtractTreeDownErr:
  If Err <> 0 Then WriteLog
  
End Function

Public Function OpenDBNew(rs_Obj As ADODB.Recordset, rs_Rel As ADODB.Recordset) As Boolean
'create a new DB, objects and relations tables, and update with data

Dim DB_old As Database, DB_new As Database, newDB_name As String

On Error GoTo OpenDBNewErr
  OpenDBNew = False
  
  newDB_name = Left(currentDB_Name, Len(currentDB_Name) - 4) & "_new_" & Format(Date, "YYYYMMDD") & Right(currentDB_Name, 4)
  Set DB_new = CreateDatabase(newDB_name, dbLangGeneral)
  
  DataEnv.Connections.Item("NewConn").Open DataEnv.Connections.Item("NewConn").ConnectionString & newDB_name
  
'  rs_Obj.DataSource
  rs_Obj.Open DataEnv.Connections.Item("NewConn").ConnectionString
  
 ' SELECT  INTO tr IN 'rt.mdb';
  
  
  'Database.Execute "create table table1 ( text(20), text(20),  integer2,  integer2);"
    'create a new DB
'  newDB_name = Left(currentDB_Name, Len(currentDB_Name) - 4) & "_Src_id_" & Format(Date, "YYYYMMDD") & Right(currentDB_Name, 4)
'  Set DB_new = CreateDatabase(newDB_name, dbLangGeneral)

  'connect new DB
'  DataEnv.Temp.ConnectionString = Replace(DataEnv.Temp.ConnectionString, "temp.mdb", newDB_name)
'  DataEnv.Temp.Open
  
  OpenDBNew = True
  
OpenDBNewErr:
  If Err <> 0 Then WriteLog
 
End Function

Public Function GetObjectsTreeDown(Src_id As Integer, rs_Obj As ADODB.Recordset) As Boolean
'returns all objects down the tree starting from src_id, including itself and all Generics

Dim rs As ADODB.Recordset, varBookmark As Variant, i As Integer

  GetObjectsTreeDown = False
On Error GoTo GetObjectsTreeDownErr

' all object directly related to Src_id
  DataEnv.GetAllObjectsRelatedToObject Src_id
  Set rs = DataEnv.rsGetAllObjectsRelatedToObject

  Do While Not rs.EOF
    rs_Obj.AddNew
    For i = 0 To rs.Fields.Count - 1
      rs_Obj.Fields(i).Value = rs.Fields(i).Value
    Next i
    rs.MoveNext
  Loop
  rs.Close

'add all objects down the tree starting from src_id
  rs_Obj.MoveFirst
  Do While Not rs_Obj.EOF
    DoEvents
    varBookmark = rs_Obj.Bookmark
    DataEnv.GetAllObjectsRelatedToObject rs_Obj!Obj_id
    Set rs = DataEnv.rsGetAllObjectsRelatedToObject
    
    Do While Not rs.EOF
      rs_Obj.MoveFirst
      rs_Obj.Find "Obj_id = " & rs!Obj_id, , adSearchForward, 1
      If rs_Obj.EOF Then 'record is not here - add it
        rs_Obj.AddNew
        For i = 0 To rs.Fields.Count - 1
          rs_Obj.Fields(i).Value = rs.Fields(i).Value
        Next i
      End If
      rs.MoveNext
  
    Loop
    rs.Close
    rs_Obj.Bookmark = varBookmark
    rs_Obj.MoveNext
  Loop
  
' add all Generic
   DataEnv.GetAllGenericWithRelID
   Set rs = DataEnv.rsGetAllGenericWithRelID
   
   Do While Not rs.EOF
       rs_Obj.AddNew
       For i = 0 To rs.Fields.Count - 2 'do not take last field - "relation_ID"
         rs_Obj.Fields(i).Value = rs.Fields(i).Value
       Next i
     rs.MoveNext
   Loop
   rs.Close
  
' add object itself
   rs_Obj.MoveFirst
   rs_Obj.Find "Obj_id = " & Src_id, , adSearchForward, 1
   If rs_Obj.EOF Then 'record is not here - add it
     DataEnv.ObjectInfo Src_id
     Set rs = DataEnv.rsObjectInfo
     rs_Obj.AddNew
     For i = 0 To rs.Fields.Count - 1
       rs_Obj.Fields(i).Value = rs.Fields(i).Value
     Next i
     rs.Close
  End If
  GetObjectsTreeDown = True
  
GetObjectsTreeDownErr:
  If Err <> 0 Then WriteLog
 
End Function

Public Function GetObjectsTreeDownWithGenID(Src_id As Integer, rs_Obj As ADODB.Recordset) As Boolean
'returns all objects down the tree starting from src_id, including itself and all Generics
Dim strQ As String
Dim rs As ADODB.Recordset, varBookmark As Variant, i As Integer

On Error GoTo GetObjectsTreeDownWithGenIDErr
  GetObjectsTreeDownWithGenID = False
  
'all object directly related to Src_id
GetAllObjectsRelatedToObject_withGenInfo Src_id, rs_Obj
  
'add all objects down the tree starting from src_id
  Do While Not rs_Obj.EOF
    DoEvents
    varBookmark = rs_Obj.Bookmark
    GetAllObjectsRelatedToObject_withGenInfo rs_Obj!Obj_id, rs

    Do While Not rs.EOF
      rs_Obj.MoveFirst
      rs_Obj.Find "Obj_id = " & rs!Obj_id, , adSearchForward, 1
      If rs_Obj.EOF Then 'record is not here - add it
        rs_Obj.AddNew
        For i = 0 To rs.Fields.Count - 1
          rs_Obj.Fields(i).Value = rs.Fields(i).Value
        Next i
      End If
      rs.MoveNext
  
    Loop
    rs.Close
    rs_Obj.Bookmark = varBookmark
    rs_Obj.MoveNext
  Loop
  GetObjectsTreeDownWithGenID = True

GetObjectsTreeDownWithGenIDErr:
  If Err <> 0 Then WriteLog
 
End Function

Public Function PastAll(Old_id As Integer, New_id As Integer) As Boolean
Dim strQ As String
Dim rs As ADODB.Recordset, rs_Obj As ADODB.Recordset, rs_Rel As ADODB.Recordset

'all object directly related to Start_id
  GetAllObjectsRelatedToObject_withGenInfo Old_id, rs_Obj
 
'empty relation recordset for update
  strQ = "SELECT relations.* FROM relations WHERE ((1)=(2));"
  ExecSQL strQ, rs_Rel

  Do While Not rs_Obj.EOF
    rs_Rel.AddNew
    rs_Rel!Src_Obj = New_id
    rs_Rel!dst_obj = rs_Obj!Obj_id

    rs_Rel.AddNew
    rs_Rel!Src_Obj = rs_Obj!Gen_id
    rs_Rel!dst_obj = rs_Obj!Obj_id
    rs_Obj.MoveNext
  Loop

'if any row - move back
  If Not rs_Obj.BOF Then rs_Obj.MoveFirst
  
'add all objects down the tree starting from src_id
  Do While Not rs_Obj.EOF
    DoEvents
    varBookmark = rs_Obj.Bookmark
    GetAllObjectsRelatedToObject_withGenInfo rs_Obj!Obj_id, rs

    Do While Not rs.EOF
      rs_Rel.AddNew
      rs_Rel!Src_Obj = rs_Obj!Obj_id
      rs_Rel!dst_obj = rs!Obj_id
      rs.MoveNext
     Loop
  
    If Not rs.BOF Then rs.MoveFirst
    Do While Not rs.EOF
      rs_Obj.MoveFirst
      rs_Obj.Find "Obj_id = " & rs!Obj_id, , adSearchForward, 1
      If rs_Obj.EOF And rs!Obj_id <> Old_id Then 'record is not here - add it
        rs_Obj.AddNew
        For i = 0 To rs.Fields.Count - 1
          rs_Obj.Fields(i).Value = rs.Fields(i).Value
        Next i
        
'add generic relation for new object
        rs_Rel.AddNew
        rs_Rel!Src_Obj = rs!Gen_id
        rs_Rel!dst_obj = rs!Obj_id
      End If
      rs.MoveNext
  
    Loop
    rs.Close
    rs_Obj.Bookmark = varBookmark
    rs_Obj.MoveNext
  Loop

  If Not rs_Obj.BOF Then rs_Obj.MoveFirst
  Do While Not rs_Obj.EOF
    CreateNewObject rs_Obj!obj_name, rs_Obj!obj_comment & "", rs
    If Not rs_Rel.BOF Then
      rs_Rel.MoveFirst
      Do While Not rs_Rel.EOF
        If rs_Rel!Src_Obj = rs_Obj!Obj_id Then rs_Rel!Src_Obj = rs!Obj_id
        If rs_Rel!dst_obj = rs_Obj!Obj_id Then rs_Rel!dst_obj = rs!Obj_id
        rs_Rel.MoveNext
      Loop
    End If
    
    rs.Close
    rs_Obj.MoveNext
    
  Loop
  
  rs_Obj.Close
  rs_Rel.UpdateBatch
  rs_Rel.Close

End Function
